!to "short.prg" , CBM


;---------------------------------------------
; 48 BYTES MAX FOR MY LOVELLY GOLDEN SEQUENCES
; OF COURSE - YOU CAN CHANGE SEQ ADDRESS
;---------------------------------------------

;---
LENGTH		= $61
STREAM_BYTE	= LENGTH +1
PUT			= LENGTH+2
COPY_SEQ		= LENGTH+4
;---
;=====================
* = $8000
!bin "00_gamebox.prg",,2
;====================
*= $8500
;====================

        and #$1f  ; in ACC getkey $41..$46
        tay
        pha       ; ACC = 1..6
        jsr $8138 ; finish intro and back here for decrunch and run

        pla       ; ACC = 1..6
        tax       ; X = 1..6


;====================


;==========================
;= X = nr of running prog =
;==========================
;decrunch_and_run
;==============================================================
;- get run address after depack an pu it on the stack for rts -
;==============================================================
               ; X = 1..6
               lda tb_run_lo,x ; decrease 16bit run address value by 1
               sec
               sbc #1
               tay       ; store decrease by 1 lo byte in Y
               lda tb_run_hi,x ; hi byte return going to the stack
               sbc #0
               pha
               tya              ; transfer lo byte from Y to A
               pha              ; put decreassed low byte on the stack

;===============================
;= X = file number to decrunch =
;===============================
;do_decrunch
               ; copy decruncher code to RAM

;prepare_dcr

               ldy #$00
-              lda part_01,y
               sta DECRUNCH,y
               iny
               cpy #<boro
               bcc -

               ldy #$00
-              lda part_02,y
               sta GET_STREAM_BIT,y
               iny
               cpy #<len_01
               bcc -

               txa    ; X = number of file
               tay    ; store X in Y

               ldx #0  ; file address to calculate
               stx PUT
               stx PUT+1
-
               lda tb_ad_lo,x   ; calculate file address
               clc
               adc PUT
               sta PUT
               lda tb_ad_hi,x
               adc PUT+1
               sta PUT+1
               inx
               dey
               bne -   ; or restore X value

               pha       ; high byte of start addres packed file
               and #$1f
               ora #$80  ; jum between $8000 $9fff area
               tay       ; Y = high byte start addres packed file

               ldx PUT   ; X = low byte start addres packed file

               pla       ; high byte of start addres packed file

               ;lsr      ; divide by 8192
               ;lsr
               ;lsr
               ;lsr
               ;lsr
               ;asl      ; multiply by 8
               ;asl
               ;asl

               and #$e0 ; this same effect as div by $2000 and multiply by 8
               lsr
               lsr      ; ACC = $DE00 start value

               jmp DECRUNCH_01
;=========================
part_01
!pseudopc $0100

DECRUNCH

               CMP #$80 ;in ACC first byte of packed file higgest bit indicator of depack address exist in stream
               PHP ;RAW DATA? - MAKE ACTIVE IF TRUE

               AND #$3F
               STA LENGTH
               BNE + ; golden sequences exist?
-
               JSR GET_DATA_BYTE ; copy golden sequences to buffer
               STA SEQUENCES-1,Y
+              INY
               CPY LENGTH
               BCC -

               PLP ;indicator of depack address exist in stream?
               BCC +

               JSR GET_DATA_BYTE ; get depack address and put into the PUT vector
               STA PUT
               JSR GET_DATA_BYTE
               STA PUT+1
+
;**********************
;* MAIN DECRUNCH LOOP *
;**********************
DECRUNCH_LOOP
               JSR GET_STREAM_BIT

               BCC IS_UNCRUNCH
               LDY #$00
               STY COPY_SEQ+1
               TYA
               JSR GET_STREAM_BIT
               ROL
               BNE COPY_ONLY_1
               JSR GET3_OR_6BITS
;---
COPY_ONLY_1
               STA LENGTH
               CMP #$00
               BEQ CHECK_PAGE
;=================
LOOP_COPY	;Y = #$00
		
               JSR GET_DATA_BYTE
               STA (PUT),Y
               INC PUT
               BNE *+4
               INC PUT+1
               DEC LENGTH
               BNE LOOP_COPY
;---
CHECK_PAGE
               CPY COPY_SEQ+1
               DEC COPY_SEQ+1
               BCC LOOP_COPY
;==============
IS_UNCRUNCH

               LDA #$02 	;2 BYTES SEQ?

               ;SHORTBITS 3 FOR 2BYTES SEQ
               LDY #$03
               JSR GET_STREAM_BIT

               BCC SHORT_C
               ;LDA #3	;3 BYTES SEQ?
               TYA ; Y = 3
               JSR GET_STREAM_BIT ;IN ACC #3
               BCC START_UNCRUNCH ;SEQ 3 BYTES

               JSR GET_Y_BYTES
               CMP #3
               BEQ EOF ; 3 BYTES = EOF OR LESS = GOLDEN SEQ
               BCS START_UNCRUNCH ;SEQ LONGER THAN 3 BYTES
		
;-----------------------------
;HERE SERVICE GOLDEN SEQUENCES
;-----------------------------
;CHECK_SEQ
               LDY #4
               JSR GETMANYBITS ;GET4BITS

               ;NR OF SEQ *3
               STA LENGTH
               ASL
               ADC LENGTH
               TAY
;===
               LDA SEQUENCES,Y
               STA LENGTH

               LDA SEQUENCES+2,Y ;OFFSET HI BYTE
               STA COPY_SEQ+1
               LDA SEQUENCES+1,Y ;OFFSET LO BYTE
               LDY #$00
               BEQ SHORT_WAY
;=====
EOF
               lda #$06
               sta $de00
               cli
               RTS
;===================================================
;=============      UNCRUNCHING      ===============
;===================================================
START_UNCRUNCH
                LDY #$04 	;4 BITS FOR >2 BYTES SEQ
SHORT_C         STA LENGTH	;IN ACC LENGTH OF SEQ
                JSR GET_Y_BYTES ;GET 3 OR 4 BITS
;***************************************************
SHORT_WAY
               ;SUBSTRACT OFFSET
               STA COPY_SEQ
               SEC
               LDA PUT
               SBC COPY_SEQ
               STA COPY_SEQ
               LDA PUT+1
               SBC COPY_SEQ+1
               STA COPY_SEQ+1
;---
;UNCRUNCH		;Y = 0
;inc $01  ; if depacked file is depacked far than $8000 it's need uncoment this line
-              LDA (COPY_SEQ),Y
               STA (PUT),Y
               INY
               CPY LENGTH
               BNE -
;dec $01  ; if depacked file is depacked far than $8000 it's need uncoment this line
               TYA
               CLC
               ADC PUT
               STA PUT
               BCC *+4
               INC PUT+1
               JMP DECRUNCH_LOOP
;---
boro
!realpc

part_02
!pseudopc $0350

;==========================
GET_STREAM_BIT
               ASL STREAM_BYTE
               BEQ GET_STREAM_BYTE
               RTS
;---
GET_STREAM_BYTE
               PHA
               JSR GET_DATA_BYTE
               SEC
               ROL
               STA STREAM_BYTE
               PLA
               RTS
;---
GET_DATA_BYTE

               ;inc $d020  ; if you want blinking
MGET1HI=*+2
               LDA $1000,x
               INX
               BNE +
               pha         ; store data byte
               INC MGET1HI
               lda MGET1HI
               cmp #$a0
               bne moxi
               lda #$80
               sta MGET1HI
VAL_DE         lda #$00
               clc
               adc #$08
               sta VAL_DE+1
               sta $de00
moxi           pla          ; restore data byte
+
               rts
;============

;---
GET3MANYBITS   LDY #3 ; 3 BITS GET
GETMANYBITS	          ; IN Y REG HOW MANY BITS TO GET
               LDA #$00
               BEQ GETCRUNCHBYTES
;---
LOWER	         LDA #$01
               RTS
;===
GET3_OR_6BITS
               JSR GET3MANYBITS
               CMP #7
               BNE GETBYTESTOCOPY
;GETNEXT3BITS
               JSR GET3MANYBITS ;IN ACC #BITS - 7 , C=0
               ADC #7
               BNE GETBYTESTOCOPY
GET_Y_BYTES
               JSR GETMANYBITS
;---
GETBYTESTOCOPY
               LDY #$00
               STY COPY_SEQ+1
               TAY
               BEQ LOWER

               LDA #$01
GETCRUNCHBYTES
-
               JSR GET_STREAM_BIT
               ROL
               ROL COPY_SEQ+1
               DEY
               BNE -
               RTS
;---
SEQUENCES = *
;=========================
;= ACC start $DE00 value =
;= X;Y LO/HI add of prog =
;=========================
DECRUNCH_01
               sei
               sta $de00
               sta VAL_DE+1      ; $DE00 actual value
               STY MGET1HI       	; LO BYTE START DATA
               LDY #$00
               sty STREAM_BYTE
               JSR GET_DATA_BYTE  ; get the first byte of packed file
               jmp DECRUNCH
eddy
len_01 = eddy - GET_STREAM_BIT

!realpc
;=======
;=====================
tb_ad_lo
   !byte <files_offset
   !byte <5695
   !byte <8982
   !byte <11602
   !byte <10390
   !byte <11610
   !byte <7695
;---
tb_ad_hi
   !byte >files_offset
   !byte >5695
   !byte >8982
   !byte >11602
   !byte >10390
   !byte >11610
   !byte >7695
;---
;---
; 01 5695, 02 8982, 03 11602, 04 10390, 05 11610, 06 7695
; 01 080d, 02 080d, 03 0810, 04 0880, 05 081d, 06 082d
tb_run_lo
     !byte <$080d ; dummy byte

     !byte <$080d
     !byte <$080d
     !byte <$0810
     !byte <$0880
     !byte <$081d
     !byte <$082d
tb_run_hi
     !byte >$080d ; dummy byte

     !byte >$080d
     !byte >$080d
     !byte >$0810
     !byte >$0880
     !byte >$081d
     !byte >$082d
;==========================
my_files
files_offset = my_files - $8000
!bin "000_files.bin",26300,0
;!bin "000_files.bin",,0
;knc


